#; Programming for IoT

## Overview

Internet of Things indicates a variety of devices connected via the Internet, including wearable devices, sensors deployed on buildings, industrial plants, production and distribution energy systems and in general on cyber-physical systems. IoT technology is widely adopted in many application domains, such as smart factories, buildings and districts for energy monitoring or surveillance, environment monitoring and control of natural phenomena, within transport systems for traffic management and finally within medical devices.
In this context, the aim of the course is to give the student ability to program embedded devices connected to the network using programming paradigms for distributed, parallel and object oriented systems. The ultimate goal will be the ability of programming in the Internet-of-Things and Cyber-Physical-Systems world. Students must acquire the ability to deploy and use of web services and middleware tools and related protocols (MQTT, REST).
The student will also acquire the ability to program according paradigms publish / subscribe. The student will explore the concepts and tools for interoperability between heterogeneous devices, protocols, Machine-to-Machine, operating systems-oriented smart objects and programming with real-time constraints and energy consumption. Finally, it will be handled aspects related to IoT data processing using machine learning techniques such as recurrent neural networks.
During the course will be presented case studies related to monitoring systems within smart cities and smart factories and includes a series of laboratory exercises where the student will implement the concepts of programming networked embedded devices equipped with sensors and actuators, and allowing remote interaction with these devices.

## Expected learning outcomes

The course aims to provide students with the knowledge of object oriented programming and tools for its implementation in Python. Knowledge of the protocols for implementing web service oriented communication paradigms. Knowledge of the main tools for programming environment in real-time and in the presence of sensors and actuators. Tools for data analysis using machine learning.

The student will learn how to design a complete IoT system (microservice-based) and deploy it in a realistic application domain, starting data collection on IoT devices, data organization on the host, data processing, visualisation and user interaction

## Course topics

* Introduction to object oriented programming and Python
* XML, JSON formats

* IoT devices and communication protocols 
* Programming distributed objects using Web Services
* RestFULL Web Services (GET, PUT, POST, DELETE methods)
  
* Microservices and Middleware programming 
* Middlewares
* Dockers
  
* IoT communication protocols e piattaforme IoT 
* Publish/subscribe communication paradigms
* MQTT, COAP
* Thingspeak, Amazon, IBM Bluemix
  
* IoT data processing 
* Machine learning methods
* Time series analysis and stream processing
* Recurrent neural networks
  
* Labs 
* Programming IoT devices and platforms 
